.686
.model flat,stdcall 
option casemap:none
.xmm

include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib

.data
align 16
  actarr db   1,  3,  2,  3,  16,  6,  9, 48,  14,  8, 42, 27,  19, 15,  7, 40
  maxarr db   5,  7, 11, 13,  17, 19, 23, 53,  29, 31, 59, 37,  41, 43, 47, 61

  ones16 db 1, 1, 1, 1,  1, 1, 1, 1,   1, 1, 1, 1,  1, 1, 1, 1
  plus24 db 2, 2, 2, 2,  2, 2, 2, 2,   2, 2, 2, 2,  2, 2, 2, 2
  xswap6 db 6, 6, 6, 6,  6, 6, 6, 6,   6, 6, 6, 6,  6, 6, 6, 6

  xeroes db 0, 0, 0, 0,  0, 0, 0, 0,   0, 0, 0, 0,  0, 0, 0, 0
;   movdqa   xmm6, xswap6   ; 6
;   movdqa   xmm2, mamarr   ; 2
       ; xmm5, k
       ; xmm6, t
       ; xmm7, c

  zeroes dd 0         ;  k  ebx     plus24 db 2,2,2,2
         dd 0
  anycnt dd 0
  allcnt dd 0         ;  totals dd 0

  times  dd 10000000
  szCap  db "SS2",0
  P      dd 0
  PID    dd 0

  CrTm   dd 0, 0
  ExTm   dd 0, 0
  KnTm   dd 0, 0
  UsTm   dd 0, 0

  szFmt  db "%lu",13,10,"%lu",13,10,"%lu",13,10,"%lu",13,10,0
  szMsg  db 100 dup (0)


.code
start:
   movdqa   xmm0, actarr   ; 0  actarr  a
   movdqa   xmm3, maxarr   ; 3  maxarr  m
   movdqa   xmm1, ones16   ; 1  16 1s   1
   movdqa   xmm2, xmm3     ;
   psubb    xmm2, xmm1     ; 2  maxarr - 1
   movdqa   xmm4, plus24   ; 4  plus24  p24
   pxor     xmm6, xmm6     ; t = 0
   mov ebx, times  ; use ebx for times

alliters:
   xor esi, esi    ; use esi for zeroes

manybites:
   paddb    xmm0, xmm4     ; a = a + p24                  ; add the 2 or 4

   movdqa   xmm7, xmm0     ; c = a
   movdqa   xmm5, xmm0     ; k = a
   ; pxor     xmm6, xmm6     ; t = 0   should remain 0 so no need to reset it every iteration

;------ does the cmp and sub
   pcmpgtb  xmm7, xmm2     ; if c > m ? c = 255 : c = 0   ; if c >= max ? sub max : sub 0
   pand     xmm7, xmm3     ; and c, x   c = x  OR c = 0   ; x = 5,7,11,13
   psubb    xmm0, xmm7     ; sub a, c

;------ does the 0 detect and count
   pcmpeqb  xmm5, xmm3     ; if k = x ? k = 255 : k = 0   ; find zeroes ( equal max )
   pand     xmm5, xmm1     ; and k, 1   k = 255 -> 1 OR k = 0 -> 0
   psadbw   xmm5, xmm6     ; word0 = sum 7:0 differences, word4 = sum 15:8 differences; res 0..8
   pshufd   xmm7, xmm5, 11100110b   ; 3212 1032 3012   
   paddw    xmm7, xmm5     ; padd b w d q usb usw  all would work


   movd      esi, xmm7     ; movd zeroes, xmm5   THIS is a problem 
;------ in place of movd ----------
   ; movdqa   xeroes, xmm7
   ; mov esi, dword ptr xeroes ; movzx esi, word ptr xeroes   could replace both instructions
   ; and esi, 0FFFFh           ; 
;------ in place of movd -----------

   ; movdqa   actarr, xmm0   ; save it/update the copy in memory

;------ if needed  anycnt+1  allcnt+zeroes
   cmp esi, 0      ; cmp zeroes, 0      ; test esi, 0     ; 
   jz  @F
   inc anycnt      ; inc anycnt
   add allcnt, esi ; add allcnt, zeroes
@@:
   pxor     xmm4, xswap6   ; xor dword ptr plus24, 06060606h    switch 2 to 4 OR 4 to 2
   ; movdqa   plus24, xmm4   ; save it/update the copy in memory
   dec ebx         ; dec times
   jnz alliters


   invoke GetCurrentProcess
   mov P, eax
   invoke GetProcessTimes, P, addr CrTm, addr ExTm, addr KnTm, addr UsTm

   invoke wsprintf, addr szMsg, addr szFmt, anycnt, allcnt, KnTm+0, UsTm+0
   invoke MessageBox, NULL, addr szMsg, addr szCap, MB_OK
   invoke ExitProcess, NULL
end start